/* -*- mode: c++; c-basic-offset: 2; -*- */

#ifndef GENERAL__TIMEOUT_HH
#define GENERAL__TIMEOUT_HH

#include "general/config.h"

#include <pthread.h>
#include <stdexcept>

#include <memory>

#include "general/ConditionalVariable.hh"
#include "general/Task.hh"

namespace General
{
  class Task;

  class TimeoutException
    : public std::runtime_error
  {
  public:
    TimeoutException( const std::string& msg );
  };

  void Timeout( Task* CallerTask, int Seconds );
}
#endif /* GENERAL__TIMEOUT_HH */
